#include "stc8h.h"
#include "intrins.h"
#include "stdio.h"

#define FOSC            11059200UL
#define BRT             (65536 - FOSC / 115200 / 4)

int *BGV;                                       //ѹλΪ(mV)
bit busy;

void UartIsr() interrupt 4
{
    if (TI)
    {
        TI = 0;
        busy = 0;
    }
    if (RI)
    {
        RI = 0;
    }
}

void UartInit()
{
    SCON = 0x50;
    TMOD = 0x00;
    TL1 = BRT;
    TH1 = BRT >> 8;
    TR1 = 1;
    AUXR = 0x40;
    busy = 0;
}

void UartSend(char dat)
{
    while (busy);
    busy = 1;
    SBUF = dat;
}

char putchar(char c)
{
	UartSend(c);
	return c;
}

void ADCInit()
{
    ADCTIM = 0x3f;                              //ADCڲʱ

    ADCCFG = 0x2f;                              //ADCʱΪϵͳʱ/2/16
    ADC_CONTR = 0x8f;                           //ʹADCģ,ѡ15ͨ
}

int ADCRead()
{
    int res;

    ADC_CONTR |= 0x40;                          //ADת
    _nop_();
    _nop_();
    while (!(ADC_CONTR & 0x20));                //ѯADCɱ־
    ADC_CONTR &= ~0x20;                         //ɱ־
    res = (ADC_RES << 8) | ADC_RESL; //ȡADC

    return res;
}

void main()
{
    int res;
    int vcc;
    int i;

    P_SW2 |= 0x80;      //չĴʹ

    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;

    BGV = (int idata *)0xef;
    ADCInit();                                  //ADCʼ
    UartInit();                                 //ڳʼ

    ES = 1;
    EA = 1;

    printf("BGV=%umV\r\n",*BGV);                //BGVֵ

//  ADCRead();
//  ADCRead();                                  //ǰݽ鶪

    res = 0;
    for (i=0; i<8; i++)
    {
        res += ADCRead();                       //ȡ8
    }
    res >>= 3;                                  //ȡƽֵ
    printf("res=%u\r\n",res);                   //ADCֵ

    vcc = (int)(1024L * *BGV / res);            //(10λADC㷨)VREFܽŵѹ,صѹ
//  vcc = (unsigned int)(4096L * *BGV / res);   //(12λADC㷨)VREFܽŵѹ,صѹ
                                                //ע,˵ѹĵλΪ(mV)
    printf("vcc=%umV\r\n",vcc);                 //ѹֵ
//    UartSend(vcc >> 8);                       //ѹֵ
//    UartSend(vcc);

    while (1);
}

